#include "xdef.h"
#include <math.h>
#include <stdlib.h>

/*

 ᮡ⨩, 뢠 ⭮ﬨ  䫠

:

                  .            
  (****)		       10		   10	       -
 ।               8                15.3         EOS
窠                           8                  15         EOS
稥                      0                  .1         EOS
᪫⥫             0                  .1         EOS
⥫              0                  .1         EOS
                         5                  10         PUN
                            0                   5         PUN
                    30		    0	      PUN
  稥  (**)               0                   7         PUN
     (***)          0                   0         PUN
  窠  ⮩               0                   1       PUN & EOS
  .窠                6.5                   0         PUN
  .窠 (*)             50                   6       PUN & QUOT
  . ᪮                  4                   0         PUN
  . ᪮ (*)             50                   6       PUN & BRAK
।  ᪮          10                 -10          -
 ᮡ⢥                 5                   0          -
砫 ᨢ                  5                  .5          -
 ᨢ                  60                   6          -
 ""                      ??                   0    WASPUN=1 & NOONE
 ""                      ??                   0    WASPUN=0 & NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0    WASPUN=0 & NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0         NOONE
 ""                      ??                   0         NOONE

(*)  ⮬ 砥 ⭮ 樠   ୮
    
// (**) 稥 㢥稢 ⭮ ⮩  ⮩  
(***)    樠 ⭮ 
(****) ⭮ 㢥稢 ᫥  ।

*/


static poss possibilities_data [POSSIBLES] = {
  { 0, 15, 10},		// par
  { 0, 15, 10},		// .
  { 0,  0,1.5},		// ...
  { 0,  0,  2},		// !
  { 0, 18, 15}, 	// ,
  { 0,  0,  1},		// -
  { 0,  2,  3},		// :
  { 0,  2,  2},		// , -
  { 0,  0, .5},		// ;
  { 0,6.5,  0},		// <<
  { 0, 50, 20},		// >>
  { 0,  4,  0},		// (
  { 0, 50, 40},		// )
  { 0, 10,-10},		// (...)
  { 0,  4,  0},		// Name
  { 0,  0,  2},		// ?
  { 0,100,  0},		// ᨬ
  { 0, 15, 17},		//  ।
  { 0, .2, .05},	// {\it
  { 0, 70, 30},		// }
  { 0,  1,1.5},		// : <
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
  { 0,  0,  0},		// 
};

//  //

poss *possibilities (void) {

  return (&possibilities_data[0]);

}

//  //

//static double this_cycle_value;

void new_cycle (void) {
  return;

//  this_cycle_value = (double) random (256);

}

//  //

int possible (double poss) {

  if (poss > (double) random (256)/*this_cycle_value*/)
    return 1;
  return 0;

}

//  //

#define         P	possibilities_data[index]

void advance_possibility (int index) {

double x;

   if (P.increment == 0) {
     P.value += (random (P.initial*300) - P.initial*150)/1000;
     if (P.value < P.initial*.5 || P.value > P.initial*2)
       P.value = P.initial;
     return;
   }
   if (P.initial >= 256) {
     decrease_possibility (index);
     return;
   }

//   x = ((sqrt (256*(P.value-P.initial))/P.increment)+1E-16) + 1;
//   P.value = (P.increment*P.increment*x*x/256)+P.initial;

   if (P.value < P.initial)
     P.value = P.initial;
   x = sqrt ((P.value-P.initial)/(256 - P.initial))*256/P.increment + 1;
   P.value = (256 - P.initial) * P.increment * P.increment * x * x / (256.0 * 256.0) + P.initial;

}

//  //

void increase_possibility (int index) {

  if (P.initial * 1.5 >= 256)
    return;
  P.initial *= 1.5;
  advance_possibility (index);

}

//  //

void decrease_possibility (int index) {

  P.initial /= 1.5;
  init_possibility (index);

}

//  //

void init_possibility (int index) {

  P.value = P.initial;

}

//  //

void init_possibilities (void) {

int c;

  for (c = 0; c < POSSIBLES; ++ c)
    possibilities_data[c].value = possibilities_data[c].initial;

//  PS_CBRACKET = 0;
//  PS_CQUOTE = 0;

}

//  //
