#define X_PARAGRAPH	0
#define X_POINT         1
#define X_THREEPOINT    2
#define X_EXCLAM        3
#define X_COMMA         4
#define X_DASH          5
#define X_COLON         6
#define X_COMMADASH     7
#define X_SEMICOLON     8
#define X_OQUOTE        9
#define X_CQUOTE        10
#define X_OBRACKET      11
#define X_CBRACKET      12
#define X_SENTBRAK	13
#define X_NAME		14
#define X_QUESTION	15
#define X_SPECIAL	16
#define X_EOS		17
#define X_OITALIC	18
#define X_CITALIC	19
#define X_DIRECT	20

#define POSSIBLES	32

#define PS_PARAGRAPH    ((possibilities() + X_PARAGRAPH )->value)
#define PS_POINT        ((possibilities() + X_POINT     )->value)
#define PS_THREEPOINT   ((possibilities() + X_THREEPOINT)->value)
#define PS_EXCLAM       ((possibilities() + X_EXCLAM    )->value)
#define PS_COMMA        ((possibilities() + X_COMMA     )->value)
#define PS_DASH         ((possibilities() + X_DASH      )->value)
#define PS_COLON        ((possibilities() + X_COLON     )->value)
#define PS_COMMADASH    ((possibilities() + X_COMMADASH )->value)
#define PS_SEMICOLON    ((possibilities() + X_SEMICOLON )->value)
#define PS_OQUOTE       ((possibilities() + X_OQUOTE    )->value)
#define PS_CQUOTE       ((possibilities() + X_CQUOTE    )->value)
#define PS_OBRACKET     ((possibilities() + X_OBRACKET  )->value)
#define PS_CBRACKET     ((possibilities() + X_CBRACKET  )->value)
#define PS_SENTBRAK     ((possibilities() + X_SENTBRAK  )->value)
#define PS_NAME         ((possibilities() + X_NAME      )->value)
#define PS_QUESTION     ((possibilities() + X_QUESTION  )->value)
#define PS_SPECIAL      ((possibilities() + X_SPECIAL   )->value)
#define PS_EOS	        ((possibilities() + X_EOS       )->value)
#define PS_OITALIC	((possibilities() + X_OITALIC   )->value)
#define PS_CITALIC	((possibilities() + X_CITALIC   )->value)
#define PS_DIRECT 	((possibilities() + X_DIRECT    )->value)

typedef struct p {
  double value;
  double initial;
  double increment;
} poss;

void init_possibilities (void);
void init_possibility (int index);
void advance_possibility (int index);
int possible (double poss);
poss *possibilities (void);
void new_cycle (void);
void increase_possibility (int index);
void decrease_possibility (int index);
