//	TXTFRESH.PRJ	Text fresher
//		FUNCS.C Text dealing functions
//			(C) 1995 by OMS

#include "txtfresh.h"

//  //

short isletter (unsigned char c) {

 return (
     ((c < 0xf2) && (c > 0xdf)
       ||
      (c < 0xb0) && (c > 0x7f)
     )
 );
}

//  //

int isvowel (unsigned char c) {

  switch ((signed char) upc(c)) {
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
      return (1);
    default:
      return (0);
  }
}

//  //

int iscons (unsigned char c) {

  if (isletter (c) && ! isvowel (c))
    return (1);
  return (0);
}

//  //

int isspace (unsigned char c) {

  return (c == ' ' || c == '\t' || c == '\n' || c == '\r');

}

//  //

int getword (char *dest, FILE *fp) {

int ch;

//  while ((ch = getc (fp)) != EOF && !isspace (ch) && !ispunc (ch))
  while ((ch = getc (fp)) != EOF && isletter (ch))
    *dest ++ = ch;

  *dest = '\x0';

  if (ch != EOF)
    return 1;
  else
    return 0;
}

//  //

unsigned char upc (unsigned char c) {

#define	uc	unsigned char

  if (c >= (uc) '' && c <= (uc) '')
    return (c - 32);
  else if (c >= (uc) '' && c <= (uc) '')
    return (c - 80);
  return (c);
}

//  //
