/* ------------------------------------------------------ */
/*                135-Kb Word Constructor                 */
/*              (C) 1992 by OnMind Systems                */
/*                    User interface                      */
/* ------------------------------------------------------ */

#include "twindow.h"
WINDOW                   *wwork, *werr, *whelp, *wexit, *wask, *wvar;
int t_save ();

/* ------------------------------------------------------ */

void disp_init (void) {
/*
  union REGS r;

  r.x.ax = 3;
  int86 (0x10, &r, &r);
*/

  if ((*((int far *) 0x410) & 0x30) == 0x30)
    video_start = (int far *) 0xB0000000lu;        /* Monochrome adapter */
  else
    video_start = (int far *) 0xB8000000lu;        /* Color adapter */

  outportb (0x3d8, *((char far *) 0x465) | 0x20);  /* Assure blink */
}

/* ------------------------------------------------------ */

void interrupt ce_handler () {     /* Critical Error Handler */

  ioerr = 1;
  _AL = 0;
  return;
}

/* ------------------------------------------------------ */

int cb_handler () {

  return (1);
}

/* ------------------------------------------------------ */

void disp_box (char *s, int x1, int y1, int x2, int y2, int fgc, int bgc) {

  register unsigned attr = (fgc + (bgc << 4)) << 8;
  register char *p = s;
  int space = 1; /* string/space switch */
  int end = 1;
  register int i;
  int j;

  for (j = y1 * 80; j <= y2 * 80; j += 80) {   /* strings */

    for (i = x1; i <= x2; i ++) { /* symbols */
      if (space) {
        if (*p == '\r') {
          p += 2;
          space = 0; /* spaces pass */
        }
        if (!(*p)) end = 0;
      }

      if (space && end)
        * (int far *) (video_start + i + j) = *p ++ | attr;
      else
        * (int far *) (video_start + i + j) = ' ' | attr;
    }
    if (space && end)
      while (*p ++ != '\n');       /* rewind the scrap of string */
    space = 1;
  }
}

/* ------------------------------------------------------ */

void save_scr () {

  memcpy (vbuf, (void far *) video_start, 4000);
}

/* ------------------------------------------------------ */

void load_scr () {

  memcpy ((void far *) video_start, vbuf, 4000);
}

/* ------------------------------------------------------ */

void help (int what) {

  save_scr ();

  switch (what) {
    case 1:
      disp_box (
" :  Ŀ\r\n"
"\"⪨\" (塞) 㪢 뤥 -\r\n"
",   ᯮ 㪮 ઠ ᫮:\r\n"
"஡ -  㪢, \"-\" - ᭠,  \"*\"  -\r\n"
"ᮣ᭠.  ஬  ᪮ 䠢, -\r\n"
"⢮ :                           \r\n"
"                                            \r\n"
"Left, Right, Home, End                \r\n"
"Space                    ⠢ ⮳\r\n"
"Del, Backspace       㪢/⮳\r\n"
"*            ४⥫ /ᮣ\r\n"
"+                     ४⥫ ॣ࠳\r\n"
"Ins/F7                 ⢥न 㪢/᫮\r\n"
"Enter            稭 (᪠) ᫮\r\n"
"Esc                            ᫮\r\n"
"F8/Alt-F8          / ਠ\r\n"
"F6           室  ७ ᫮  \r\n"
"Ctrl-F6/Alt-F6 室/७ ᫮  \r\n"
" Esc ",
      17, 3, 62, 21, BLACK, CYAN);
      break;
    case 2:
      disp_box (
" :  Ŀ\r\n"
"饥 ᫮ 뤥 栭,    ०\r\n"
"   ᫮  -  .\r\n"
"  ⥪ - \"५\",  Home,  End,\r\n"
"PgUp, PgDn. ⢮ ⠪ :    \r\n"
"                                            \r\n"
"Ctrl-PgUp/Ctrl-PgDn      砫/ ⥪⠳\r\n"
"Del, Backspace                  ᫮\r\n"
"Ins                    ᫮\r\n"
"Space                 ਮ⠭ 栭\r\n"
"Enter                ⠢ ॢ ப\r\n"
"Ctrl-Left/Ctrl-Right           ᫮\r\n"
"Ctrl-S   ⠬ ⥪饥  ᫥饥\r\n"
"Ctrl-Y                         ப\r\n"
"F4                          맢 ।\r\n"
"Alt-F4    맢 ।  㪠 \r\n"
"Alt-F5                   ࠭\r\n"
"F6     室  ७ ᫮  \r\n"
"Alt-F6                 室  \r\n"
" Esc ",
      17, 3, 62, 22, BLACK, CYAN);
  }
  while (!query ());
  load_scr ();
}

/* ------------------------------------------------------ */

void clrdis_win (WINDOW *wnd) {

  clear_window (wnd);
  wnd -> _cr = 0;
  wnd -> _wsp = 0;
  display_window (wnd);
}

/* ------------------------------------------------------ */

void dis_work (char *s) {

  clrdis_win (wwork);
  wwork -> _cr += (26 - strlen (s)) / 2;
  wprintf (wwork, s);
}

/* ------------------------------------------------------ */

void quitting () {

  free (pb);
  close_all ();
  setvect (0x24, oldvec);
  textbackground (BLACK);
  textcolor (LIGHTGRAY);
  clrscr ();
  cur_on ();
  free (vbuf);
  puts ("OnMind Systems /  ⥬");

  _exit (0);
}

/* ------------------------------------------------------ */

int yesno (int x, int y) {

  int yes = 1;

  textcolor (BLACK);
  do {
    gotoxy (x, y);
    if (yes) textbackground (CYAN);
    else textbackground (LIGHTGRAY);
    psepri ("    ");
    if (!yes) textbackground (CYAN);
    else textbackground (LIGHTGRAY);
    psepri ("   ");
    switch (getch ()) {
      case 0:
        switch (getch ()) {
          case LEFT:
          case RIGHT:
            yes = !yes;
            break;
        }
        break;
      case SPACE:
        yes = !yes;
        break;
      case 'y':
        yes = 1;
      case ENTER:
        return (yes);
      case 'n':
      case ESC:
        return (0);
    }
  } while (1);
}

/* ------------------------------------------------------ */

void quit () {

  clrdis_win (wexit);
  wprintf (wexit, "    ?  ");

  cur_off ();
  if (yesno (34, 14)) {
    hide_window (wexit);
    t_save ();
    quitting ();
  }
  hide_window (wexit);
}

/* ------------------------------------------------------ */

void cry (char *s) {

  cur_off ();
  clrdis_win (werr);
  textbackground (RED);
  textcolor (YELLOW + BRIGHT);
  gotoxy (54, 17); psepri (" Esc ");
  gotoxy (22 + ((39 - strlen (s)) / 2), 16);
  psepri (s);
  while (!query ());
  hide_window (werr);
}

/* ------------------------------------------------------ */

void restore_frame (int height, int len) {

  register int t;

  textbackground (BLUE);
  textcolor (LIGHTGRAY);
  gotoxy (80 - len, height);

  for (t = 0; t < len; t ++)
    putch ('');
}

/* ------------------------------------------------------ */

void put_name (int height, char *name) {     /* Write filename */

  restore_frame (height, 30);
  gotoxy (77 - strlen (name), height);
  putch (' ');
  psepri (strupr (name));
  putch (' ');
}

/* ------------------------------------------------------ */

void putnum () {

  char sn [10];

  sprintf (sn, "  %-5d", lcur + 1);

  gotoxy (11, 2);
  textbackground (BLUE);
  textcolor (WHITE);
  psepri (sn);
}

/* ------------------------------------------------------ */

void put_top (char *title) {

  register int t;

  putch ('');
  putch ('');
  putch (' ');
  psepri (title);
  putch (' ');
  for (t = wherex (); t < 80; t ++)
    putch ('');
  putch ('');
}

/* ------------------------------------------------------ */

void put_bottom () {

  register int t;

  putch ('');
  for (t = 0; t < 78; t ++)
    putch ('');
  putch ('');
}

/* ------------------------------------------------------ */

void put_middle (int height) {

  register int t;

  for (t = 0; t < height; t ++) {
    putch ('');
    gotoxy (80, wherey ());
    putch ('');
  }
}

/* ------------------------------------------------------ */

void init_win () {

  whelp = establish_window (16, 3, 19, 48);
  set_colors (NULL, ALL, CYAN, BLACK, 0);       /* Help */

  wwork = establish_window (26, 12, 3, 28);
  set_colors (NULL, ALL, LIGHTGRAY, BLACK, 0);      /* Unsqueezing */

  wask = establish_window (12, 12, 3, 55);
  set_colors (NULL, ALL, LIGHTGRAY, BLACK, 0);      /* Ask filename */

  werr = establish_window (21, 14, 3, 38);
  set_colors (NULL, ALL, RED, YELLOW, BRIGHT);       /* Error */

  wexit = establish_window (30, 11, 4, 18);
  set_colors (NULL, ALL, LIGHTGRAY, BLACK, 0);      /* Exit */

  wvar = establish_window (24, 7, VARMAX + 2, 32);
  set_colors (NULL, ALL, LIGHTGRAY, BLACK, 0);      /* Variants */
}

/* ------------------------------------------------------ */

int ones (char byte) {

  register char m;
  register int r = 0;

  for (m = 1; m; m <<= 1)
    if (byte & m) {
      r ++;
    }
  return (r);
}

/* ------------------------------------------------------ */

void check_rsd () {

  int c, c1;
  char far *p = (char *) getvect (0x1f);
  int sum = 0;

  for (c1 = 0; c1 < 16; c1 ++) {
    for (c = 0; c < 4; c ++)
      sum += ones (*p ++);
    p += 4;
  }
  if (sum < 185) {
    disp_box ("", 20, 10, 62, 19, YELLOW, BLACK);
    disp_box ("\r\n SORRY,\r\n\r\n"

              " it seems to me that you have\r\n"
              " no Russian Screen Driver loaded.\r\n\r\n"

              " Please correct the problem and try again,\r\n"
              " or run me with \"-r\" switch.\r\n\r\n"

              "                                    <Esc>",

              19, 9, 61, 18, YELLOW + BRIGHT, RED);
    while (!query ());
    quitting ();
  }
}

/* ------------------------------------------------------ */

void swin (int what) {     /* 1 = T, 0 = C */

  textbackground (BLUE);
  if (what)
    textcolor (YELLOW + BRIGHT);
  else
    textcolor (LIGHTGRAY);
  gotoxy (4, 2);
  psepri ("");

  if (!what)
    textcolor (YELLOW + BRIGHT);
  else
    textcolor (LIGHTGRAY);
  gotoxy (4, 20);
  psepri ("");
}

/* ------------------------------------------------------ */

void put_scr () {

  textbackground (BLUE);
  textcolor (LIGHTGRAY);
  clrscr ();
  textcolor (BLACK);
  textbackground (LIGHTCYAN);
  psepri (" Russian Word Constructor, Version 1.0, Copyright (C) 1992 OnMind Systems ");

  if (rsd)
    check_rsd ();

  textbackground (BLUE);
  textcolor (LIGHTGRAY);
  put_top ("");
  put_middle (16);
  put_bottom ();
  put_top ("");
  put_middle (3);
  put_bottom ();

  gotoxy (11, 21);
  psepri ("");
  gotoxy (11, 22);
  psepri ("");
  gotoxy (11, 23);
  psepri ("");

  gotoxy (1, 25);
  textbackground (LIGHTCYAN);
  clreol ();
  textcolor (BROWN);
  psepri (" F1");
  textcolor (BLACK);
  psepri (" ");

  textcolor (BROWN);
  psepri (" F2");
  textcolor (BLACK);
  psepri (" ");

  textcolor (BROWN);
  psepri (" F3");
  textcolor (BLACK);
  psepri ("䠩 ");

  textcolor (BROWN);
  psepri (" F4");
  textcolor (BLACK);
  psepri ("। ");

  textcolor (BROWN);
  psepri (" F5");
  textcolor (BLACK);
  psepri (" ");

  textcolor (BROWN);
  psepri (" F6");
  textcolor (BLACK);
  psepri (" ");

  textcolor (BROWN);
  psepri (" F9");
  textcolor (BLACK);
  psepri ("᫮ ");

  textcolor (BROWN);
  psepri (" F10");
  textcolor (BLACK);
  psepri ("室");
}

/* ------------------------------------------------------ */

void retype (char *name, char *ext) {

  char *p;

  while (((p = strrchr (name, '.')) == NULL) || *(p - 1) == '.')
    strcpy (name + strlen (name), ".");
  strcpy (++ p, ext);
}

/* ------------------------------------------------------*/

char *put_date (char *s, char sep) {

  time (&tim);
  timst = localtime (&tim);
  sprintf (s, "%02u%c%02u%c%02u",
    timst -> tm_mday, sep, timst -> tm_mon + 1, sep, timst -> tm_year);
  return (s);
}

/* ------------------------------------------------------ */

void cut_name (char *name, char *ext) {    /* Cut extra filename symbols */

  char *p;
  int l = 0;

  if (!*name) return;

  if (((p = strrchr (name, '.')) == NULL || *(p + 1) == '\\') && *ext)
						       /* If no extension, */
    retype (name, ext);                                /* set default */

  *(p + 4) = 0;                                        /* cut extension */

  if ((p = strrchr (name, '\\')) == NULL &&
      (p = strrchr (name, ':')) == NULL)
    p = name;
  else p ++;

  while (*p != '.' && *p != 0) {
    p ++;
    l ++;
  }

  if (l > 8)
    memmove (p - (l - 8), p, strlen (p) + 1);
}

/* ------------------------------------------------------ */

int askname (char *s, int what) {

  int p;
  char c;

  clrdis_win (wask);
  textbackground (LIGHTGRAY);
  textcolor (BLACK);
  gotoxy (14, 13);
  switch (what) {
    case 0: psepri ("  "); break;
    case 1: psepri ("  "); break;
    case 2: psepri ("  ");
  }
  gotoxy (61, 15); psepri (" Esc ");
  wprintf (wask, "  䠩:");
  disp_box (s, 25, 13, 65, 13, BLACK, CYAN);
  gotoxy (26 + (p = strlen (s)), 14);
  cur_on ();
  c = getch ();
  if (!(c == BACKSPACE || c == ENTER || c == 0)) {
    *s = 0;
    p = 0;
  }
  if (c == 0) {
    if (!((c = getch ()) == LEFT || c == RIGHT || c == DEL ||
        c == HOME || c == END)) {
      *s = 0;
      p = 0;
    }
    goto edit0;
  }

  do {
    switch (c) {
      case 0:
        c = getch ();
edit0:
        switch (c) {
          case LEFT:
            if (p) p --;
            break;
          case RIGHT:
            if (s [p]) p ++;
            break;
          case HOME:
            p = 0;
            break;
          case END:
            p = strlen (s);
            break;
          case DEL:
            memmove (s + p, s + p + 1, strlen (s + p));
            break;
          case F10:
          case ALT_X:
            quit ();
            textbackground (CYAN);
            break;
        }
        break;
      case BACKSPACE:
        if (p) {
          p --;
          memmove (s + p, s + p + 1, strlen (s + p));
        }
        break;
      case ENTER:
        hide_window (wask);
        cur_off ();
        return (0);
      case ESC:
        hide_window (wask);
        cur_off ();
        return (1);
      case SPACE:
        s [p] = 0;
        break;
      default:
        if (c < 128 && c > 20 && strlen (s) < 40) {
          memmove (s + p + 1, s + p, strlen (s + p) + 1);
          s [p ++] = c;
        }
        break;
    }

    disp_box (s, 25, 13, 65, 13, BLACK, CYAN);
    gotoxy (26 + p, 14);
    cur_on ();
    c = getch ();
  } while (1);
}

/* ------------------------------------------------------ */

void guess_name (char *s) {

  char s2 [45];
  char *p, *p2 = s2;
  int d, m, y;

  time (&tim);
  timst = localtime (&tim);
  if (p = strrchr (s, '\\'))
    s = p + 1;

  for (p = s; *p && *p != '.'; p ++)
    if (!isdigit (*p) && *p != '-')
      return;
  p = s;

  if ((d = atoi (s)) == 0 || d > 31)
    return;
  sprintf (p2, "%02u-", d); p2 += 3;
  while (isdigit (*p)) p ++;
  if (*p == '-') p ++;

  if ((m = atoi (p)) == 0 || m > 12)
    m = timst -> tm_mon + (d <= timst -> tm_mday);
  sprintf (p2, "%02u-", m); p2 += 3;
  while (isdigit (*p)) p ++;
  if (*p == '-') p ++;

  if ((y = atoi (p)) == 0 || y > timst -> tm_year)
    y = timst -> tm_year;
  sprintf (p2, "%02u", y); p2 += 2;
  while (isdigit (*p)) p ++;

  strcpy (p2, p);
  strcpy (s, s2);
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */

