/* ------------------------------------------------------ */
/*  English-Russian Transcriber, V1.0, (C) OnMind Systems */
/* ------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define isvow(c) (c == 'A' || c == 'E' || c == 'I' || c == 'O' || c == 'U')
#define issonant(c) (c == 'L' || c == 'M' || c == 'R' || c == 'N')
#define iszvonk(c) (issonant(c) || c == 'B' || c == 'D' || c == 'G' || c == 'Z')
#define NEXT *(p + 1)

char ch = 0;

/* ------------------------------------------------------ */

void word (char *s) {

  char c;

  do {
    if (ch) {
      c = ch;
      ch = 0;
    } else
      c = fgetc (stdin);
    if (feof (stdin))
      return;
    if (!isalpha (c))
      fputc (c, stdout);
  } while (!isalpha (c));

  *(s ++) = toupper (c);

  while (isalpha (c = fgetc (stdin)) && !feof (stdin))
    *(s ++) = toupper (c);
  ch = c;

  *s = 0;
}

/* ------------------------------------------------------ */

int cov (char *p) {

  if (isvow (*(p + 1)))
    return (0);

  p += 2;
  if (*p == 'H' && *(p - 1) == 'G')
    p += 2;
  if (isvow (*p) && !(*p == 'I' && NEXT == 'E'))
    return (0);
  return (1);
}

/* ------------------------------------------------------ */

void main () {

  char w [40], wo [50];
  char *p, *po, *p1;

  do {
    word (w);
    for (p = w, po = wo; *p; p ++, po ++) {
      switch (*p) {
        case 'A':
          if (cov (p))
            *po = '';
          else {
            *(po ++) = '';
            *po = '';
            if (NEXT == 'I')
              p ++;
          }
          break;
        case 'E':
          if (NEXT == 0 || NEXT == 'S' && *(p + 2) == 0 ||
              !memcmp (w, "SOME", 4) && p - w == 3) {
            for (p1 = w; p1 < p; p1 ++)
              if (isvow (*p1)) {
                po --;
                goto ex;
              }
              *po = '';
              break;
          }
          if (NEXT == 'E' || NEXT == 'A') {
            *po = '';
            p ++;
            break;
          }
          *po = '';
ex:
          break;
        case 'I':
          if (cov (p))
            *po = '';
          else {
            if (NEXT == 'O' && *(p + 2) == 'N') {
              p += 3;
              *po = '';
              break;
            }
            *(po ++) = '';
            *po = '';
          }
          break;
        case 'O':
          if (NEXT == 'W') {
            *(po ++) = '';
            *po = '';
            if (NEXT == 'W')
              p ++;
            break;
          }
          if (NEXT == 'O') {
            *po = '';
            p ++;
            break;
          }
          if (NEXT == 'U' || NEXT == 'A') {
            *po ++ = '';
            *po = '';
            p ++;
            break;
          }
          *po = '';
          break;
        case 'U':
          if (cov (p))
            *po = '';
          else {
            *(po ++) = '';
            *po = '';
          }
          break;
        case 'B':
          *po = '';
          break;
        case 'C':
          if (NEXT == 'E' || NEXT == 'I' || NEXT == 'Y')
            *po = '';
          else {
            if (NEXT == 'H') {
              *po = '';
              p ++;
              break;
            }
            if (NEXT == 'K')
              p ++;
            *po = '';
          }
          break;
        case 'D':
          *po = '';
          break;
        case 'F':
          *po = '';
          break;
        case 'G':
          if (NEXT == 'H') {
            p ++;
            po --;
            break;
          }
          if (NEXT == 'E' || NEXT == 'I' || NEXT == 'Y') {
            *(po ++) = '';
            *po = '';
          } else
            *po = '';
          break;
        case 'H':
          *po = '';
          break;
        case 'J':
          *(po ++) = '';
          *po = '';
          break;
        case 'K':
          if (NEXT == 'N') {
            po --;
            break;
          }
          *po = '';
          break;
        case 'L':
          *po = '';
          break;
        case 'M':
          *po = '';
          break;
        case 'N':
          *po = '';
          break;
        case 'P':
          if (NEXT == 'H') {
            *po = '';
            p ++;
            break;
          }
          *po = '';
          break;
        case 'Q':
          p ++;
          *po ++ = '';
          *po = '';
          break;
        case 'R':
          *po = '';
          break;
        case 'S':
          if (NEXT == 'H') {
            *po = '';
            p ++;
            break;
          }
          if (isvow (*(p - 1)) && (isvow (NEXT) || NEXT == 0))
            *po = '';
          else
            if (NEXT == 0 && iszvonk (*(p - 1)))
              *po = '';
            else
              *po = '';
          break;
        case 'T':
          if (NEXT == 'H') {
            if (*(p + 2) == 'I')
              *po = '';
            else
              *po = '';
            p ++;
            break;
          }
          if (NEXT == 'I' && *(p + 2) == 'O')
            *po = '';
          else
            *po = '';
          break;
        case 'V':
          *po = '';
          break;
        case 'W':
          *po = '';
          break;
        case 'X':
          *po ++ = '';
          *po = '';
          break;
        case 'Y':
          if (isvow (NEXT))
            *po = '';
          else
            *po = '';
          break;
        case 'Z':
          *po = '';
          break;
      }
    }
    *po = 0;
    for (po = wo; *po; po ++)
      fputc (*po, stdout);
  } while (!feof (stdin));
}






